// process a 10x10 DataMatrix bitmap in "input.png" to a slice image in "output.png"
void setup() 
{
  size(1482, 1482);
  noStroke();
  noSmooth();

  background(0);
  loadPixels();
  
  // starting positions for the large and small barcodes
  int xLg1 = 790;
  int yLg1 = 700;
  
  int xLg2 = 720;
  int yLg2 = 720;
    
  int xSm1 = 665;
  int ySm1 = 725;
  
  int xSm2 = 620;
  int ySm2 = 730;
  
  int xStart = -1;
  int yStart = -1;
  color black = color(0);
  color white = color(255);
  
  PImage orig;
  orig = loadImage("input.png");
  orig.loadPixels();
  
  // look for the first black pixel, indicating the start of the data matrix
  for(int x = 0; x < orig.width; x++)
  {
    for(int y = 0; y < orig.height; y++)
    {
      if(orig.get(x, y) == black)
      {
        xStart = x;
        yStart = y;
        break;
      }
    }
    if(xStart >= 0)
      break;
  }
        
  // lay down a single-pixel checkerboard that provides the "white" background
  for(int x = 600; x < 900; x++)
  {
    for(int y = 500; y < 980; y++)
    {
      if (((x ^ y) & 1) == 1)
        set(x, y, white);
    }
  }
  
  int yOff = 150;
  
  // lay down black background for smallest symbols
  fill(0);
  rect(xSm1, ySm1, 31, 31);
  rect(xSm2, ySm2, 21, 21);
  rect(xSm1, ySm1 - yOff, 31, 31);
  rect(xSm2, ySm2 - yOff, 21, 21);
  rect(xSm1, ySm1 + yOff, 31, 31);
  rect(xSm2, ySm2 + yOff, 21, 21);
  
  for(int offset = -yOff; offset <= yOff; offset += yOff)
  {
    // the original barcode extends from (xStart, yStart) to (xStart + 9, yStart + 9) 
    for(int i = 0; i < 10; i++)
    {
      for(int j = 0; j < 10; j++)
      {
        // the slice images are reversed, left to right, and we only need to draw the black cells
        if(orig.get(xStart + 9 - i, yStart + j) == black)
        {
          // for the largest size, each cell is 8x8 pixels
          for(int x = 0; x < 8; x++)
            for(int y = 0; y < 8; y++)
              set(xLg1 + i * 8 + x, yLg1 + j * 8 + y + offset, black);
              
          // for the second largest, ech cell is 4x4 pixels 
          for(int x = 0; x < 4; x++)
            for(int y = 0; y < 4; y++)
              set(xLg2 + i * 4 + x, yLg2 + j * 4 + y + offset, black);
        }
        else
        {
          // the smallest ones are drawn in white on black
          // for the second smallest, each cell is 2x2 pixels
          for(int x = 0; x < 2; x++)
            for(int y = 0; y < 2; y++)
              set(xSm1 + 1 + i * 3 + x, ySm1 + 1 + j * 3 + y + offset, white);
              
         // for the smallest, each cell is a single pixel    
         set(xSm2 + 1 + i * 2, ySm2 + 1 + j * 2 + offset, white);  
        }
      }
    }
  }        
  // save the slice image
  save("output.png");
}